# -*- coding: utf-8 -*-

# Songwrite 2
# Copyright (C) 2007 Jean-Baptiste LAMY -- jibalamy@free.fr
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import songwrite2.model   as model
import songwrite2.plugins as plugins

plugins.Plugin("additional_instruments")

class Banjo5GTablatureString(model.TablatureString):
  def value_2_text(self, value):
    if value == self.base_note: return u"0"
    return unicode(value - self.base_note + 5)
  
  def text_2_value(self, text):
    text = int(text)
    if text <= 5: return self.base_note
    return text + self.base_note - 5
  
model.Banjo5GTablatureString = Banjo5GTablatureString

def Banjo5GView(partition):
  return model.TablatureView(partition, _(u"Banjo 5G"), [
    model.TablatureString(62, -1),
    model.TablatureString(59, -1),
    model.TablatureString(55, -1),
    model.TablatureString(50, -1),
    Banjo5GTablatureString(67, -1),
    ])
Banjo5GView.default_instrument = 105
model.VIEWS["tab"].append(Banjo5GView)

def MandolinView(partition):
  return model.TablatureView(partition, _(u"Mandolin"), [
    model.TablatureString(76, -1),
    model.TablatureString(69, -1),
    model.TablatureString(62, -1),
    model.TablatureString(55, -1),
    ])
MandolinView.default_instrument = 105
model.VIEWS["tab"].append(MandolinView)


